Index: /branches/prototype-v0/zoo-project/zoo-kernel/service_internal_ms.c
===================================================================
--- /branches/prototype-v0/zoo-project/zoo-kernel/service_internal_ms.c	(revision 853)
+++ /branches/prototype-v0/zoo-project/zoo-kernel/service_internal_ms.c	(revision 854)
@@ -138,4 +138,5 @@
     exit(-1);
   }
+  int finalProto=-1;
   map *msOgcVersion=getMapFromMaps(m,"main","msOgcVersion");
   map *dataPath=getMapFromMaps(m,"main","dataPath");
@@ -147,10 +148,19 @@
   map* protoMap=getMap(tmpI->content,"msOgc");
   map* versionMap=getMap(tmpI->content,"msOgcVersion");
-  char options[3][5][25]={
+  char options[4][5][25]={
     {"WMS","1.3.0","GetMap","layers=%s","wms_extent"},
     {"WFS","1.1.0","GetFeature","typename=%s","wcs_extent"},
-    //{"WCS","1.1.0","GetCoverage","coverage=%s","wcs_extent"}
-    {"WCS","2.0.0","GetCoverage","coverageid=%s","wcs_extent"}
+    {"WCS","2.0.0","GetCoverage","coverageid=%s","wcs_extent"},
+    {"WCS","1.1.0","GetCoverage","coverage=%s","wcs_extent"}
   };
+  map* datatype=getMap(tmpI->content,"geodatatype");
+  if(datatype==NULL || strncmp(datatype->value,"other",5)==0){
+    setMapInMaps(m,"lenv","mapError","true");
+    setMapInMaps(m,"lenv","locator",tmpI->name);
+    setMapInMaps(m,"lenv","message",_("The ZOO-Kernel was able to retrieve the data but could not read it as geographic data."));
+    if(getMapFromMaps(m,"lenv","state")==NULL)
+      errorException (m, _("Unable to find any geographic data"), "WrongInputData", tmpI->name);
+    return;
+  }
   int proto=0;
   if(rformat==NULL){
@@ -194,7 +204,8 @@
 
   char* webService_url=(char*)malloc((strlen(msUrl->value)+strlen(format->value)+strlen(tmpI->name)+strlen(width->value)+strlen(height->value)+strlen(extent->value)+256)*sizeof(char));
-  map* datatype=getMap(tmpI->content,"geodatatype");
   
   if(proto>0){
+    if(proto==2)
+      finalProto=1;
     sprintf(webService_url,
 	    "%s?map=%s/%s_%s.map&request=%s&service=%s&version=%s&%s&format=%s&bbox=%s&crs=%s",
@@ -248,9 +259,12 @@
   }
   addToMap(tmpI->content,"Reference",webService_url);
-
+  memset(layers,0,128);
+  sprintf(layers,options[proto][3],tmpI->name);
   protoVersion=options[proto][1];
   extent=getMap(tmpI->content,options[proto][4]);
   memset(webService_url,0,strlen(webService_url));
   if(proto>0){
+    if(proto==2)
+      finalProto=1;
     sprintf(webService_url,
 	    "%s?map=%s/%s_%s.map&request=%s&service=%s&version=%s&%s&format=%s&bbox=%s&crs=%s",
@@ -292,4 +306,27 @@
     addToMap(tmpI->content,"ref_wms_link",webService_url);
   }
+  if(finalProto>0){
+    proto=3;
+    memset(layers,0,128);
+    sprintf(layers,options[proto][3],tmpI->name);
+    protoVersion=options[proto][1];
+    extent=getMap(tmpI->content,options[proto][4]);
+    memset(webService_url,0,strlen(webService_url));
+    sprintf(webService_url,
+	    "%s?map=%s/%s_%s.map&request=%s&service=%s&version=%s&%s&format=%s&bbox=%s&crs=%s",
+	    msUrl->value,
+	    dataPath->value,
+	    tmpI->name,
+	    sid->value,
+	    options[proto][2],
+	    options[proto][0],
+	    protoVersion,
+	    layers,
+	    rformat->value,
+	    extent->value,
+	    crs->value
+	    );
+    addToMap(tmpI->content,"ref_wcs_preview_link",webService_url);
+  }
   if(hasCRS==0){
     freeMap(&crs);
@@ -299,5 +336,4 @@
   free(rformat);
   free(webService_url);
-  dumpMaps(tmpI);
 }
 
@@ -492,6 +528,5 @@
   /**
    * Try to load the file as ZIP
-   */
-
+   *
   OGRDataSourceH poDS1 = NULL;
   OGRSFDriverH *poDriver1 = NULL;
@@ -534,4 +569,6 @@
     fprintf(stderr,"Unable to access the DataSource as ZIP File\n");
     setMapInMaps(conf,"lenv","message","Unable to open datasource in read only mode");
+    fprintf(stderr,"Remove ZIP File!\n");
+    unlink(odsName);
     //OGR_DS_Destroy(poDS1);
   }else{
@@ -594,7 +631,7 @@
     }
     OGR_DS_Destroy(poDS1);
-  }
+    }
   free(sdsName);
-  free(dsName);
+  free(dsName);*/
   
   OGRDataSourceH poDS = NULL;
@@ -649,4 +686,6 @@
     myLayer->status = MS_ON;
     msConnectLayer(myLayer,MS_OGR,pszDataSource);
+
+    addIntToMap(output->content,"nb_features",OGR_L_GetFeatureCount(poLayer,1));
 
     /**
@@ -811,5 +850,5 @@
    */
   GDALAllRegister();
-  hDataset = GDALOpen( pszFilename, GA_ReadOnly );
+  hDataset = GDALOpen( pszFilename, GA_Update );
   if( hDataset == NULL ){
 #ifdef DEBUGMS
@@ -866,4 +905,5 @@
   m->width=GDALGetRasterXSize( hDataset );
   m->height=GDALGetRasterYSize( hDataset );
+  addIntToMap(output->content,"nb_pixels",GDALGetRasterXSize( hDataset )*GDALGetRasterYSize( hDataset ));
   
   /**
@@ -880,5 +920,9 @@
     setSrsInformations(output,m,myLayer,pszProjection);
   }else{
-    fprintf(stderr,"NO SRS FOUND ! %s\n",GDALGetProjectionRef( hDataset ));    
+    fprintf(stderr,"NO SRS FOUND ! %s\n",GDALGetProjectionRef( hDataset ));
+    CPLErr sp=GDALSetProjection( hDataset , "+init=epsg:4326" );
+    if(sp!=CE_None){
+      fprintf(stderr,"NO SRS FOUND ! %s\n",CPLGetLastErrorMsg());
+    }
   }
 
@@ -905,4 +949,12 @@
       addToMap(output->content,"boundingbox",extent);
     }
+  }else{
+    int scale=1;
+    if(m->width>2048){
+      addIntToMap(output->content,"width",2048);
+      scale=2048/m->width;
+    }else
+      addIntToMap(output->content,"width",m->width);
+    addIntToMap(output->content,"height",m->height*scale);
   }
 
@@ -919,9 +971,13 @@
   }
   if(nBandsI>=3)
-    msLayerAddProcessing(myLayer,"BANDS=1,2,3");
+    if(nBandsI==4)
+      msLayerAddProcessing(myLayer,"BANDS=1,2,3,4");
+    else
+      msLayerAddProcessing(myLayer,"BANDS=1,2,3");
   else if(nBandsI>=2)
     msLayerAddProcessing(myLayer,"BANDS=1,2");
   else
     msLayerAddProcessing(myLayer,"BANDS=1");
+  
 
   /**
@@ -929,7 +985,7 @@
    */
   char lBands[7];
-  memset(&nBands,0,7);
   char *nameBands=NULL;
   for( iBand = 0; iBand < nBandsI; iBand++ ){
+    memset(&lBands,0,7);
     sprintf(lBands,"Band%d",iBand+1);    
     if(nameBands==NULL){
@@ -937,5 +993,5 @@
       sprintf(nameBands,"%s",lBands);
     }else{
-      if(iBand<4){
+      /*if(iBand<4)*/{
 	char *tmpS=zStrdup(nameBands);
 	nameBands=(char*)realloc(nameBands,(strlen(tmpS)+strlen(lBands)+2)*sizeof(char));
@@ -954,21 +1010,20 @@
    */
   for( iBand = 0; iBand < nBandsI; iBand++ ){
-    //int         bGotNodata;//, bSuccess;
-    double      adfCMinMax[2]/*, dfNoData*/;
-    //int         nBlockXSize, nBlockYSize, nMaskFlags;
-    //double      /*dfMean, dfStdDev*/;
+    double      pdfMin, pdfMax, pdfMean, pdfStdDev;
     hBand = GDALGetRasterBand( hDataset, iBand+1 );
 
     CPLErrorReset();
-    GDALComputeRasterMinMax( hBand, FALSE, adfCMinMax );
+    GDALComputeRasterStatistics( hBand, TRUE, &pdfMin, &pdfMax, &pdfMean, &pdfStdDev, NULL,NULL);
     char tmpN[21];
     sprintf(tmpN,"Band%d",iBand+1);
     if (CPLGetLastErrorType() == CE_None){
-      char tmpMm[100];
-      sprintf(tmpMm,"%.3f %.3f",adfCMinMax[0],adfCMinMax[1]);
+      char tmpMm[100],tmpMp[100];
+      sprintf(tmpMm,"%.3f %.3f",pdfMin,pdfMax);
+      sprintf(tmpMp,"SCALE_%d=%.3f,%.3f",iBand+1,pdfMean-(2*pdfStdDev),pdfMean+(2*pdfStdDev));
       char tmpI[31];      
       sprintf(tmpI,"%s_interval",tmpN);
       msInsertHashTable(&(myLayer->metadata), tmpI, tmpMm);
-
+      if(pdfMax>255)
+	msLayerAddProcessing(myLayer,tmpMp);
       map* test=getMap(output->content,"msClassify");
       if(test!=NULL && strncasecmp(test->value,"true",4)==0){
@@ -990,7 +1045,7 @@
 	  
 	if(nBandsI==1){
-	  double delta=adfCMinMax[1]-adfCMinMax[0];
+	  double delta=pdfMax-pdfMin;
 	  double interval=delta/10;
-	  double cstep=adfCMinMax[0];
+	  double cstep=pdfMin;
 	  for(i=0;i<10;i++){
 	    /**
@@ -1036,5 +1091,5 @@
 	  
 	  char tmpMm[100];
-	  sprintf(tmpMm,"%.3f %.3f",adfCMinMax[0],adfCMinMax[1]);
+	  sprintf(tmpMm,"%.3f %.3f",pdfMin,pdfMax);
 	  
 	}
@@ -1046,5 +1101,4 @@
 	  myLayer->offsite.blue=0;
 	}
-	msLayerAddProcessing(myLayer,"RESAMPLE=BILINEAR");
       }
     }
@@ -1056,4 +1110,5 @@
 
   }
+  msLayerAddProcessing(myLayer,"RESAMPLE=BILINEAR");
 
   m->layerorder[m->numlayers] = m->numlayers;
@@ -1081,24 +1136,27 @@
       ext="json";
 
-  map* tmpMap=getMapFromMaps(conf,"main","dataPath");
-  map* sidMap=getMapFromMaps(conf,"lenv","usid");
-  char *pszDataSource=(char*)malloc((strlen(tmpMap->value)+strlen(sidMap->value)+strlen(outputs->name)+17)*sizeof(char));
-  sprintf(pszDataSource,"%s/ZOO_DATA_%s_%s.%s",tmpMap->value,outputs->name,sidMap->value,ext);
-  int f=zOpen(pszDataSource,O_WRONLY|O_CREAT,S_IRUSR|S_IWUSR|S_IRGRP|S_IWGRP|S_IROTH|S_IWOTH);
-  map *gfile=getMap(outputs->content,"generated_file");
-  if(gfile!=NULL){
-    readGeneratedFile(conf,outputs->content,gfile->value);	    
-  }
-  map* sizeMap=getMap(outputs->content,"size");
-  map* vData=getMap(outputs->content,"value");
-  if(sizeMap!=NULL){
-    zWrite(f,vData->value,atoi(sizeMap->value)*sizeof(char));
-  }
-  else{
-    zWrite(f,vData->value,(strlen(vData->value)+1)*sizeof(char));
-  }
-  close(f);
-  addToMap(outputs->content,"storage",pszDataSource);
-  free(pszDataSource);
+  map* storage=getMap(outputs->content,"storage");
+  if(storage==NULL){
+    map* tmpMap=getMapFromMaps(conf,"main","dataPath");
+    map* sidMap=getMapFromMaps(conf,"lenv","usid");
+    char *pszDataSource=(char*)malloc((strlen(tmpMap->value)+strlen(sidMap->value)+strlen(outputs->name)+17)*sizeof(char));
+    sprintf(pszDataSource,"%s/ZOO_DATA_%s_%s.%s",tmpMap->value,outputs->name,sidMap->value,ext);
+    int f=zOpen(pszDataSource,O_WRONLY|O_CREAT,S_IRUSR|S_IWUSR|S_IRGRP|S_IWGRP|S_IROTH|S_IWOTH);
+    map *gfile=getMap(outputs->content,"generated_file");
+    if(gfile!=NULL){
+      readGeneratedFile(conf,outputs->content,gfile->value);	    
+    }
+    map* sizeMap=getMap(outputs->content,"size");
+    map* vData=getMap(outputs->content,"value");
+    if(sizeMap!=NULL){
+      zWrite(f,vData->value,atoi(sizeMap->value)*sizeof(char));
+    }
+    else{
+      zWrite(f,vData->value,(strlen(vData->value)+1)*sizeof(char));
+    }
+    close(f);
+    addToMap(outputs->content,"storage",pszDataSource);
+    free(pszDataSource);
+  }
 
   /*
@@ -1174,4 +1232,15 @@
 #endif
 
+  outputFormatObj *o6=msCreateDefaultOutputFormat(NULL,"GDAL/GTiff","geotiff");
+  if(!o6)
+    fprintf(stderr,"Unable to initialize GDAL driver !\n");
+  else{
+    o6->imagemode=MS_IMAGEMODE_BYTE;
+    o6->mimetype=strdup("image/geotiff");
+    o6->inmapfile=MS_TRUE;
+    msAppendOutputFormat(myMap,msCloneOutputFormat(o6));
+    msFreeOutputFormat(o6);
+  }
+
   /*
    * Set default projection to EPSG:4326
@@ -1262,6 +1331,8 @@
   msSaveMap(myMap,mapPath);
   free(mapPath);
+  //msFreeSymbolSet(&myMap->symbolset);
+  msFreeMap(myMap);
+  //msFree(myMap);
   msGDALCleanup();
-  msFreeMap(myMap);
 }
 
Index: /branches/prototype-v0/zoo-project/zoo-kernel/service_internal_python.c
===================================================================
--- /branches/prototype-v0/zoo-project/zoo-kernel/service_internal_python.c	(revision 853)
+++ /branches/prototype-v0/zoo-project/zoo-kernel/service_internal_python.c	(revision 854)
@@ -57,5 +57,5 @@
  * from the ZOO-Kernel Python environment:
  *  - "_" corresponding to the PythonTranslate function
- *  - "updte_status" corresponding to the PythonUpdateStatus function
+ *  - "update_status" corresponding to the PythonUpdateStatus function
  * @see PythonTranslate, PythonUpdateStatus
  */
@@ -163,5 +163,5 @@
     fprintf(stderr,"PYTHON SUPPORT (%i)\n",strlen(tmp->value));
 #endif
-    python_path=(char*)malloc((strlen(tmp->value))*sizeof(char));
+    python_path=(char*)malloc((strlen(tmp->value)+1)*sizeof(char));
     sprintf(python_path,"%s",tmp->value);
     hasToClean=1;
@@ -281,5 +281,5 @@
 	dumpMaps(*real_outputs);
 #endif
-      }else{	  
+      }else{
 	PythonZooReport(m,tmp->value,0);
 	res=-1;
@@ -323,10 +323,10 @@
   char *pbt=NULL;
   if(PyString_Check(trace)){
-    pbt=(char*)malloc((7+strlen(PyString_AsString(trace))+1)*sizeof(char));
+    pbt=(char*)malloc((8+strlen(PyString_AsString(trace)))*sizeof(char));
     sprintf(pbt,"TRACE: %s",PyString_AsString(trace));
   }
   else
     fprintf(stderr,"EMPTY TRACE ?");
-  
+
   trace=NULL;
   
Index: /branches/prototype-v0/zoo-project/zoo-kernel/sql/schema.sql
===================================================================
--- /branches/prototype-v0/zoo-project/zoo-kernel/sql/schema.sql	(revision 853)
+++ /branches/prototype-v0/zoo-project/zoo-kernel/sql/schema.sql	(revision 854)
@@ -31,6 +31,6 @@
 -- Create a dedicated schema to store all tables
 -- Uncomment the following 2 lines to activate the schema use
--- CREATE SCHEMA zoo;
--- SET search_path TO zoo;
+-- CREATE SCHEMA process;
+-- SET search_path TO process;
 --------------------------------------------------------------------------------
 -- Services table
@@ -45,10 +45,6 @@
        creation_time timestamp with time zone default now(),
        end_time timestamp with time zone default NULL,
-       -- queue_duration ,
-       -- run_duration ,
        progress int,
-       message TEXT,
-       -- data_lifetime timestamp with time zone default now() + interval '48 hours',
-       rps_step int4 default 0
+       message TEXT
 );
 --------------------------------------------------------------------------------
@@ -56,5 +52,5 @@
 -- Used to store the response provided by a services running asynchronously
 create table responses (
-       uuid text references process(uuid) ON DELETE CASCADE,
+       uuid text references services(uuid) ON DELETE CASCADE,
        content text,
        creation_time timestamp with time zone default now()
Index: /branches/prototype-v0/zoo-project/zoo-kernel/sqlapi.c
===================================================================
--- /branches/prototype-v0/zoo-project/zoo-kernel/sqlapi.c	(revision 853)
+++ /branches/prototype-v0/zoo-project/zoo-kernel/sqlapi.c	(revision 854)
@@ -70,6 +70,8 @@
   int i=0;
   maps* cconf=getMaps(conf,key);
-  if(cconf==NULL)
+  if(cconf==NULL){
+    fprintf(stderr,"%s %d\n",__FILE__,__LINE__);
     return "-1";
+  }
   int len=0;
   for(i=0;i<6;i++){
@@ -119,6 +121,10 @@
 int _init_sql(maps* conf,const char* key){
   char* sqlInitString=_createInitString(conf,key);
+  fprintf(stderr,"Try to connect to: %s %s !\n",key,sqlInitString);
+  fflush(stderr);  
   if(strncmp(sqlInitString,"-1",2)==0)
     return -1;
+  fprintf(stderr,"Try to connect to: %s !\n",key);
+  fflush(stderr);  
   OGRSFDriver *poDriver = NULL;
   OGRRegisterAll();
@@ -195,7 +201,9 @@
  */
 void close_sql(maps* conf,int cid){
-  if( zoo_ResultSet != NULL )
+  if( zoo_ResultSet != NULL ){
     zoo_DS[cid]->ReleaseResultSet( zoo_ResultSet );
-  if(zoo_DS!=NULL){
+    zoo_ResultSet=NULL;
+  }
+  if(zoo_DS!=NULL && zoo_DS[cid]!=NULL){
 #if GDAL_VERSION_MAJOR >= 2
     GDALClose(zoo_DS[cid]);
@@ -223,5 +231,5 @@
  */
 OGRLayer *fetchSql(maps* conf,int cid,const char* sqlQuery){
-  if(zoo_DS[cid]==NULL)
+  if(zoo_DS==NULL || zoo_DS[cid]==NULL)
     return NULL;
   OGRLayer *res=NULL;
@@ -250,4 +258,6 @@
 int execSql(maps* conf,int cid,const char* sqlQuery){
   int res=-1;
+  if(zoo_DS == NULL || zoo_DS[cid]==NULL)
+    return -1;
   zoo_ResultSet = zoo_DS[cid]->ExecuteSQL( sqlQuery, NULL, NULL);
   if( zoo_ResultSet != NULL ){
@@ -371,17 +381,13 @@
   char *sqlQuery=(char*)malloc((strlen(schema->value)+strlen(msg->value)+strlen(p->value)+strlen(sid->value)+64+1)*sizeof(char));
   sprintf(sqlQuery,"UPDATE %s.services set status=$$%s$$,message=$$%s$$ where uuid=$$%s$$;",schema->value,p->value,msg->value,sid->value);
-  if( zoo_ds_nb==
-#ifdef META_DB
-      1
-#else
-      0
-#endif
-      ){
+  if(zoo_ds_nb==0){
     init_sql(conf);
     zoo_ds_nb++;
   }
-  execSql(conf,zoo_ds_nb-1,sqlQuery);
-  cleanUpResultSet(conf,zoo_ds_nb-1);
-  free(sqlQuery);
+  execSql(conf,0,sqlQuery);
+  cleanUpResultSet(conf,0);
+  close_sql(conf,0);
+  free(sqlQuery);
+  setMapInMaps(conf,"lenv","ds_nb","0");
   return 0;
 }
@@ -439,4 +445,7 @@
   int zoo_ds_nb=getCurrentId(conf);
   map *schema=getMapFromMaps(conf,"database","schema");
+  OGRFeature  *poFeature = NULL;
+  const char *tmp1=NULL;
+  int hasRes=-1;
   char *sqlQuery=(char*)malloc((strlen(schema->value)+strlen(pid)+82+1)*sizeof(char));
   sprintf(sqlQuery,
@@ -454,7 +463,4 @@
   }
   execSql(conf,zoo_ds_nb-1,sqlQuery);
-  OGRFeature  *poFeature = NULL;
-  const char *tmp1;
-  int hasRes=-1;
   if(zoo_ResultSet!=NULL){
       while( (poFeature = zoo_ResultSet->GetNextFeature()) != NULL ){
@@ -472,6 +478,5 @@
   if(hasRes<0)
     tmp1=NULL;
-  else
-    cleanUpResultSet(conf,zoo_ds_nb-1);
+  cleanUpResultSet(conf,zoo_ds_nb-1);
   free(sqlQuery);
   return (char*)tmp1;
@@ -534,5 +539,5 @@
   //close_sql(conf,zoo_ds_nb-1);
   free(sqlQuery);
-  end_sql();
+  //end_sql();
 }
 
@@ -555,5 +560,6 @@
     zoo_ds_nb++;
   }
-  execSql(conf,zoo_ds_nb-1,sqlQuery);
+  if(execSql(conf,zoo_ds_nb-1,sqlQuery)<0)
+    return NULL;
   OGRFeature  *poFeature = NULL;
   const char *tmp1;
Index: /branches/prototype-v0/zoo-project/zoo-kernel/sshapi.c
===================================================================
--- /branches/prototype-v0/zoo-project/zoo-kernel/sshapi.c	(revision 853)
+++ /branches/prototype-v0/zoo-project/zoo-kernel/sshapi.c	(revision 854)
@@ -29,4 +29,5 @@
 
 #include "sshapi.h"
+#include "service_internal.h"
 
 SSHCON *sessions[MAX_PARALLEL_SSH_CON];
@@ -94,15 +95,31 @@
   int port=22;
 
-  fprintf(stderr,"%s %d\n",__FILE__,__LINE__);
-  fflush(stderr);
-
-  map* hpc_host=getMapFromMaps(conf,"HPC","host");
-  map* hpc_port=getMapFromMaps(conf,"HPC","port");
-  map* hpc_user=getMapFromMaps(conf,"HPC","user");
-  map* hpc_password=getMapFromMaps(conf,"HPC","password");
-  map* hpc_public_key=getMapFromMaps(conf,"HPC","key");
-
-  fprintf(stderr,"%s %d\n",__FILE__,__LINE__);
-  fflush(stderr);
+  map* hpc_config=getMapFromMaps(conf,"lenv","configId");
+  
+  map* hpc_host=getMapFromMaps(conf,hpc_config->value,"ssh_host");
+  map* hpc_port=getMapFromMaps(conf,hpc_config->value,"ssh_port");
+  map* hpc_user=getMapFromMaps(conf,hpc_config->value,"ssh_user");
+  map* hpc_password=getMapFromMaps(conf,hpc_config->value,"ssh_password");
+  map* hpc_public_key=getMapFromMaps(conf,hpc_config->value,"ssh_key");
+
+  char ip[100];
+  struct hostent *my_hostent;
+  struct in_addr **addrs;
+  
+  if (hpc_host != NULL) {
+    // Fetch ip address for the hostname
+    if ( (my_hostent = gethostbyname( hpc_host->value ) ) == NULL){
+      herror("gethostbyname");
+      setMapInMaps(conf,"lenv","message",_("Issue when invoking gethostbyname!"));
+      return NULL;
+    }
+ 
+    addrs = (struct in_addr **) my_hostent->h_addr_list;
+  
+    for(i = 0; addrs[i] != NULL; i++) {
+      strcpy(ip , inet_ntoa(*addrs[i]) );
+      break;
+    }
+  }
 
 #ifdef WIN32
@@ -117,7 +134,6 @@
 #endif
 
-  // TODO: fetch ip address for the hostname
   if (hpc_host != NULL) {
-    hostaddr = inet_addr(hpc_host->value);
+    hostaddr = inet_addr(ip);
   } else {
     setMapInMaps(conf,"lenv","message","No host parameter found in your main.cfg file!\n");
@@ -235,5 +251,5 @@
 int ssh_get_cnt(maps* conf){
   int result=0;
-  map* myMap=getMapFromMaps(conf,"lenv","cnt_session");
+  map* myMap=getMapFromMaps(conf,"lenv","nb_sessions");
   if(myMap!=NULL){
     result=atoi(myMap->value);
@@ -323,5 +339,5 @@
     return false;
   }
-
+  
   do {
     sessions[cnt]->sftp_session = libssh2_sftp_init(sessions[cnt]->session);
@@ -391,5 +407,5 @@
  * @param targetPath const char* defining the path for accessing the file on the
  * remote host
- * @return true in case of success, false if failure occured
+ * @return 0 in case of success, -1 if failure occured
  */
 int ssh_fetch(maps* conf,const char* localPath,const char* targetPath,int cnt){
@@ -414,65 +430,61 @@
       
       fprintf(stderr, "Unable to init SFTP session\n");
-      return false;
+      return -1;
     }
   } while (!sessions[cnt]->sftp_session);
+  do {
+    sftp_handle = libssh2_sftp_open(sessions[cnt]->sftp_session, targetPath,   
+				    LIBSSH2_FXF_READ, 0);
+    if (!sftp_handle) {
+      if (libssh2_session_last_errno(sessions[cnt]->session) != LIBSSH2_ERROR_EAGAIN) {
+	fprintf(stderr, " ** Unable to open file with SFTP\n");
+	return -1;
+      }
+      else {
+	//non-blocking open
+	waitsocket(sessions[cnt]->sock_id, sessions[cnt]->session); 
+      }
+    }
+  } while (!sftp_handle);
+ 
+  int result=0;
+  do {
     do {
-        sftp_handle = libssh2_sftp_open(sessions[cnt]->sftp_session, targetPath,
-
-                                        LIBSSH2_FXF_READ, 0);
- 
-        if (!sftp_handle) {
-            if (libssh2_session_last_errno(sessions[cnt]->session) != LIBSSH2_ERROR_EAGAIN) {
-                fprintf(stderr, "Unable to open file with SFTP\n");
-                return -1;
-            }
-            else {
-                fprintf(stderr, "non-blocking open\n");
-                waitsocket(sessions[cnt]->sock_id, sessions[cnt]->session); 
-            }
-        }
-    } while (!sftp_handle);
- 
-    int result=1;
-    do {
-        do {
-            rc = libssh2_sftp_read(sftp_handle, mem, sizeof(mem));
-            /*fprintf(stderr, "libssh2_sftp_read returned %d\n",
-	      rc);*/
-            if(rc > 0) {
-	      //write(2, mem, rc);
-                fwrite(mem, rc, 1, local);
-            }
-        } while (rc > 0);
- 
-        if(rc != LIBSSH2_ERROR_EAGAIN) {
-	  result=-1;
-	  break;
-        }
-
-	struct timeval timeout;
-	fd_set fd;
-        timeout.tv_sec = 10;
-        timeout.tv_usec = 0;
- 
-        FD_ZERO(&fd);
- 
-        FD_SET(sessions[cnt]->sock_id, &fd);
- 
-        rc = select(sessions[cnt]->sock_id+1, &fd, &fd, NULL, &timeout);
-        if(rc <= 0) {
-	  if(rc==0)
-            fprintf(stderr, "SFTP download timed out: %d\n", rc);
-	  else
-	    fprintf(stderr, "SFTP download error: %d\n", rc);
-	  result=-1;
-	  break;
-        }
- 
-    } while (1);
+      rc = libssh2_sftp_read(sftp_handle, mem, sizeof(mem));
+      /*fprintf(stderr, "libssh2_sftp_read returned %d\n",
+	rc);*/
+      if(rc > 0) {
+	//write(2, mem, rc);
+	fwrite(mem, rc, 1, local);
+      }
+    } while (rc > 0);
+    
+    if(rc != LIBSSH2_ERROR_EAGAIN) {
+      result=-1;
+      break;
+    }
+    
+    struct timeval timeout;
+    fd_set fd;
+    timeout.tv_sec = 10;
+    timeout.tv_usec = 0;
+ 
+    FD_ZERO(&fd);
+ 
+    FD_SET(sessions[cnt]->sock_id, &fd);
+ 
+    rc = select(sessions[cnt]->sock_id+1, &fd, &fd, NULL, &timeout);
+    if(rc <= 0) {
+      if(rc==0)
+	fprintf(stderr, "SFTP download timed out: %d\n", rc);
+      else
+	fprintf(stderr, "SFTP download error: %d\n", rc);
+      return -1;
+    }
+ 
+  } while (1);
   duration = (int)(time(NULL)-start);
   fclose(local);
   libssh2_sftp_close_handle(sftp_handle);
-
   libssh2_sftp_shutdown(sessions[cnt]->sftp_session);
   return 0;
@@ -491,19 +503,33 @@
   int exitcode;
   char *exitsignal=(char *)"none";
+  fprintf(stderr,"%s %d\n",__FILE__,__LINE__);
+  fflush(stderr);
   while( (channel = libssh2_channel_open_session(sessions[cnt]->session)) == NULL &&
 	 libssh2_session_last_error(sessions[cnt]->session,NULL,NULL,0) == LIBSSH2_ERROR_EAGAIN ) {
+    fprintf(stderr,"%s %d\n",__FILE__,__LINE__);
+    fflush(stderr);
       waitsocket(sessions[cnt]->sock_id, sessions[cnt]->session);
   }
+  fprintf(stderr,"%s %d\n",__FILE__,__LINE__);
+  fflush(stderr);
   if( channel == NULL ){
     fprintf(stderr,"Error\n");
-    return 1;
-  }
+    return -1;
+  }
+  fprintf(stderr,"%s %d\n",__FILE__,__LINE__);
+  fflush(stderr);
   while( (rc = libssh2_channel_exec(channel, command)) == LIBSSH2_ERROR_EAGAIN ) {
+    fprintf(stderr,"%s %d\n",__FILE__,__LINE__);
+    fflush(stderr);
     waitsocket(sessions[cnt]->sock_id, sessions[cnt]->session);
   }
+  fprintf(stderr,"%s %d\n",__FILE__,__LINE__);
+  fflush(stderr);
   if( rc != 0 ) {
     fprintf(stderr,"Error\n");
     return -1;
   }
+  fprintf(stderr,"%s %d\n",__FILE__,__LINE__);
+  fflush(stderr);
 
   map* tmpPath=getMapFromMaps(conf,"main","tmpPath");
@@ -513,4 +539,6 @@
   FILE* logFile=fopen(logPath,"wb");
   free(logPath);
+  fprintf(stderr,"%s %d\n",__FILE__,__LINE__);
+  fflush(stderr);
   while(true){
     int rc;
@@ -535,8 +563,16 @@
       break;
   }
+  fprintf(stderr,"%s %d\n",__FILE__,__LINE__);
+  fflush(stderr);
   fclose(logFile);
+  fprintf(stderr,"%s %d\n",__FILE__,__LINE__);
+  fflush(stderr);
   exitcode = 127;
+  fprintf(stderr,"%s %d\n",__FILE__,__LINE__);
+  fflush(stderr);
   while( (rc = libssh2_channel_close(channel)) == LIBSSH2_ERROR_EAGAIN )
     waitsocket(sessions[cnt]->sock_id, sessions[cnt]->session);
+  fprintf(stderr,"%s %d\n",__FILE__,__LINE__);
+  fflush(stderr);
   
   if( rc == 0 ) {
@@ -545,4 +581,6 @@
 				    NULL, NULL, NULL, NULL, NULL);
   }
+  fprintf(stderr,"%s %d\n",__FILE__,__LINE__);
+  fflush(stderr);
   
   if (exitsignal)
@@ -550,4 +588,6 @@
   else
     fprintf(stderr, "\nEXIT: %d bytecount: %d\n", exitcode, bytecount);
+  fprintf(stderr,"%s %d\n",__FILE__,__LINE__);
+  fflush(stderr);
   
   libssh2_channel_free(channel);
@@ -643,8 +683,8 @@
   }
 #ifdef DEBUG
-  fprintf(stderr,"%s %d\n",__FILE__,__LINE__);
+  fprintf(stderr,"*** %s %d\n",__FILE__,__LINE__);
   fflush(stderr);
   dumpMaps(getMaps(*conf,"uploadQueue"));
-  fprintf(stderr,"%s %d\n",__FILE__,__LINE__);
+  fprintf(stderr,"*** %s %d\n",__FILE__,__LINE__);
   fflush(stderr);
 #endif
@@ -660,6 +700,21 @@
 	getMapArray(queueMaps->content,"targetPath",i)
       };
-      fprintf(stderr,"%s %d %s %s\n",__FILE__,__LINE__,argv[1]->value,argv[2]->value);
-      ssh_copy(*conf,argv[1]->value,argv[2]->value,ssh_get_cnt(*conf));
+      fprintf(stderr,"*** %s %d %s %s\n",__FILE__,__LINE__,argv[1]->value,argv[2]->value);
+      /**/zooLock* lck;
+      if((lck=lockFile(*conf,argv[1]->value,'w'))!=NULL){/**/
+	if(ssh_copy(*conf,argv[1]->value,argv[2]->value,ssh_get_cnt(*conf))!=true){
+	  char* templateStr=_("Unable to copy over SSH the file requested for setting the value of %s.");
+	  char *tmpMessage=(char*)malloc((strlen(templateStr)+strlen(argv[0]->value)+1)*sizeof(char));
+	  sprintf(tmpMessage,templateStr,argv[0]->value);
+	  setMapInMaps(*conf,"lenv","message",tmpMessage);
+	  free(tmpMessage);
+	  unlockFile(*conf,lck);
+	  return false;
+	}
+	/**/unlockFile(*conf,lck);
+      }else{
+	setMapInMaps(*conf,"lenv","message",_("Unable to lock the file for upload!"));
+	return false;
+      }/**/
     }    
   }
Index: /branches/prototype-v0/zoo-project/zoo-kernel/sshapi.h
===================================================================
--- /branches/prototype-v0/zoo-project/zoo-kernel/sshapi.h	(revision 853)
+++ /branches/prototype-v0/zoo-project/zoo-kernel/sshapi.h	(revision 854)
@@ -57,5 +57,6 @@
 #include <sys/time.h>
 #endif
- 
+
+#include <netdb.h>
 #include <arpa/inet.h>
 #include <sys/types.h>
